package com.example.aped.communication;

import java.util.Dictionary;
import java.util.List;

public interface IXML {
    /**
     * downloads the XML from the raspberry to the local folder
     * @return 0 for no errors
     */
    int download();

    /**
     * uploads the local XML to the raspberry
     * @return 0 for no errors
     */
    int upload();

    /**
     * reads the list of available devices from the XML
     * @return the device names as a list of strings
     */
    List<String> getDeviceNames();

    /**
     * reads the value info of a given device from the XML
     * @param deviceName the name of the relevant device
     * @return the value info as a Dictionary
     */
    Dictionary<String, Object> getValueInfo(String deviceName);

    /**
     * reads the port information of a given device from the XML
     * @param deviceName the name of the relevant device
     * @return the value info as a Dictionary
     */
    Dictionary<String, Object> getPort(String deviceName);
}
